/*
 *	*******************************************************************
 *						HIDmonpt@[EFA.
 *	
 *	`sQRPRł̎gp[ʂŏłB
 *  	text    data     bss     dec     hex filename
 *  	1656       2      52    1710     6ae main.elf
 *	
 *	RɊgĎgpł܂B
 *	
 *	R}h
 *		HIDASP_TEST
 *		HIDASP_PEEK
 *		HIDASP_POKE
 *		HIDASP_SET_PAGE
 *	̂SłB
 *	
 *	ReportID=4 (4byte) ̓ǂݎɑ΂ẮA\ߎw肳ꂽ|[g
 *	(page_addr) ̓eǂݏoāA܂.
 *	
 *	*******************************************************************
 *	
 *	`uqC^[̋@\͂܂BC^[@\ƌpŎgp
 *	ꍇ́Amain-hidasp.c  main.c ɒuMakeĂB
 *	
 *	
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

#include "usbdrv.h"
#include "hidcmd.h"

#define OPTIMIZE_SIZE		1	// r4,r5,r6,r7 globalϐƂĎgp.
								// usbdrvœWX^gpĂȂƂ.
/* ------------------------------------------------------------------------- */
#define	INCLUDE_ISPBENCH	1	// isp̒xeXg.

//	REPORT_ID.
#define ID1    1
#define ID2    2
#define ID3    3
#define ID4    4

//	REPORT_COUNT+2̒l.
#define	LENGTH1  8
#define	LENGTH2 32
#define	LENGTH3 40
#define	LENGTH4  6

PROGMEM char usbHidReportDescriptor[51] = {
    0x06, 0x00, 0xff,              // USAGE_PAGE (Generic Desktop)
    0x09, 0x01,                    // USAGE (Vendor Usage 1)
    0xa1, 0x01,                    // COLLECTION (Application)
    0x15, 0x00,                    //   LOGICAL_MINIMUM (0)
    0x26, 0xff, 0x00,              //   LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //   REPORT_SIZE (8)

    0x85, 0x01,                    //   REPORT_ID (1)
    0x95, 0x06,                    //   REPORT_COUNT (6)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0x85, 0x02,                    //   REPORT_ID (2)
    0x95, 0x1e,                    //   REPORT_COUNT (30)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0x85, 0x03,                    //   REPORT_ID (3)
    0x95, 0x26,                    //   REPORT_COUNT (38)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0x85, 0x04,                    //   REPORT_ID (4)
    0x95, 0x04,                    //   REPORT_COUNT (4)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0xc0                           // END_COLLECTION
};

/* Note: REPORT_COUNT does not include report-ID byte */

#define	DEV_ID				0x5a	// FUSIONȂ̃t@[.

//
//	Mobt@.
//
#if OPTIMIZE_SIZE
register uchar currentPosition asm("r4");
register uchar bytesRemaining asm("r5");
register uchar page_mode   asm("r6");
register uchar page_addr   asm("r7");
#else
static uchar currentPosition;
static uchar bytesRemaining;
static uchar page_mode;
static uchar page_addr;
#endif


#define hbyte(a) (*((uchar*)&(a)+1))
#define lbyte(a) (*((uchar*)&(a)))

//
//	Mobt@.
//
typedef struct {
	uchar id[1];
	uchar buf[8];		// ReportID=1(LENGTH=7)ȊOł́Ãobt@
						// 㑱30oCgxzXgɑM邱Ƃ.
						// (擪9oCĝ݂LɂȂ)
} ReportBuf_t;

static ReportBuf_t report;

// Mobt@͎Mobt@𗬗p.
//	AA擪1oCgReport IDuKv̂,1oCg.
#define	usbData report.buf
#define	buffer  report.id

//	[ǂݏR}h\.
typedef struct {
	uchar hidasp_cmd;	// 62=poke 63=peek
	uchar count;		// ǂݍ݃oCg.
	uchar *addr;		// ǂݏAhX.
	uchar memdata[16];	// ǂݍ݃f[^. ͏݃f[^[0] }XN[1]
} MonCommand_t;

//[Aǂݏo.
static void cmd_peek(MonCommand_t *cmd)
{
	uchar *p =cmd->addr;
	uchar cnt=cmd->count;
	uchar i;
	for(i=0;i<cnt;i++) {
		usbData[i]= *p++;
	}
}
//[.(PoCg)
static void cmd_poke(MonCommand_t *cmd)
{
	uchar *p =cmd->addr;
	uchar data=cmd->memdata[0];
	uchar mask=cmd->memdata[1];
	if(mask) {	//}XNt̏.
		*p = (*p & mask) | data;
	}else{			//ׂ.
		*p = data;
	}
}

#if	INCLUDE_ISPBENCH		// isp̒xeXg.
/*
000000a8 <delay10us>:
  a8:	89 e0       	ldi	r24, 0x09	; v12clk
  aa:	00 c0       	rjmp	.+0      	; 2
  ac:	00 c0       	rjmp	.+0      	; 2
  ae:	00 c0       	rjmp	.+0      	; 2
  b0:	00 c0       	rjmp	.+0      	; 2
  b2:	81 50       	subi	r24, 0x01	; 1
  b4:	87 ff       	sbrs	r24, 7      ; 1
  b6:	f9 cf       	rjmp	.-14     	; 2
  b8:	08 95       	ret
*/

void delay10us(void)
{
	uchar i;
	for(i=0;i<10;i++) {	// 10us
		asm("rjmp .+0");	//  1us
		asm("rjmp .+0");
		asm("rjmp .+0");
		asm("rjmp .+0");
	}
}

void delay_usecx10(uchar cnt)
{
	uchar i;
	for(i=0;i<cnt;i++) {
		delay10us();
	}
}
#endif
/* ------------------------------------------------------------------------- */
/* ----------------------------- execute Buffer ---------------------------- */
/* ------------------------------------------------------------------------- */
//
//		monit̃C.
//

void monit_main(uchar *data)
{
	uint8_t cmd = data[0];

	if ( cmd == HIDASP_TEST ) {
		usbData[0] = DEV_ID;
		usbData[1] = data[1];
	}
	else if ( cmd == HIDASP_PEEK ) {
		cmd_peek((MonCommand_t *)data);
	}
	else if ( cmd == HIDASP_POKE ) {
		cmd_poke((MonCommand_t *)data);
	}
	else if ( cmd == HIDASP_SET_PAGE ) {
		page_mode = data[1];
		page_addr = data[2];
	}
}


/* ------------------------------------------------------------------------- */
/* ----------------------------- USB interface ----------------------------- */
/* ------------------------------------------------------------------------- */

// ftHgȊO usb setup R}hpPbgŉ߂.
uchar usbFunctionSetup(uchar data[8])
{
	usbRequest_t	*rq = (void *)data;
	uchar			rqType = rq->bmRequestType & USBRQ_TYPE_MASK;
	uchar			bRequest = rq->bRequest;
    if(rqType == USBRQ_TYPE_CLASS){    /* class request type */
        if(	bRequest == USBRQ_HID_GET_REPORT ) {
			report.id[0] = rq->wValue.bytes[0];    /* store report ID */
			usbMsgPtr = report.id;
		 	// ReportID:4  POLLING PORT.
			if(report.id[0]==ID4) {
				uchar *port   = (uchar *) ((int)page_addr);
				report.buf[0] = *port;
			}
			return rq->wLength.word;
		}
        if(	bRequest == USBRQ_HID_SET_REPORT ) {
			currentPosition = 0;                // initialize position index
        	bytesRemaining = rq->wLength.word;  // store the amount of data requested
          	return 0xff;						// tell driver to use usbFunctionWrite()
        }
    }
    return 0;
}


// Rg[]㑱f[^ĂꍇA8oCgPʂŎ󂯎.
// 	Eʂreport\̂ɓ.
//	ES󂯎Amonit_main()Ăяo.
uchar usbFunctionWrite(uchar *data, uchar len)
{
    if(	len > bytesRemaining) {             // if this is the last incomplete chunk
        len = bytesRemaining;               // limit to the amount we can store
	}
    bytesRemaining -= len;

	if(	currentPosition==0 ) {				// ŏ̌㑱f[^󂯎Aߎs.
		monit_main(data+1);
	}										// 8byteȍ~̃f[^͂Ƃ肠.

#if	INCLUDE_ISPBENCH		// isp̒xeXg.
	delay_usecx10(page_addr);	// 0s  2550s ҂.
#endif

	currentPosition += len;
	// S󂯎.
    if( bytesRemaining == 0 ) {
	    return 1;	// return 1 if we have all data
	}
	return 0;		// continue data.
}

/*
 *	*******************************************************************
 * 	H}́AghcijAghĉ̂ƋʂłB


         ATtiny2313
         ___    ___
RESET   [1  |__| 20] Vcc
PD0(NC) [2       19] PB7(SCK)
PD1(NC) [3       18] PB6(MISO)
XTAL2   [4       17] PB5(MOSI)
XTAL1   [5       16] PB4(RST)
PD2(12M)[6       15] PB3(PWR LED)
PD3     [7       14] PB2(ACC LED)
PD4     [8       13] PB1(NC)
PD5(NC) [9       12] PB0(NC)
GND     [10      11] PD6(NC)
        ~~~~~~~~~~~

   ---------------------------------------
   SPI:     PB7-4 ===> [Target AVR Device]
   USB:     PD4   ===> USB D-
            PD3   ===> USB D+
   XTAL:    XTAL1,2 => Crystal 12MHz
   PD2:     Clock Output(12MHz)
   ---------------------------------------
 *	*******************************************************************
 */

int main(void)
{
	DDRD = ~USBMASK;        /* all outputs except USB data */
	PORTB = 0;				/* PB3 LED(PWR) ON, PB2 LED(ACC) OFF */
	DDRB = 0;				/* PB7-0=in */

    usbInit();
    sei();
    for(;;){    /* main event loop */
        usbPoll();
    }
    return 0;
}
